NMSettingWireless: libnm Reference Manual

## NMSettingWireless NMSettingWireless — Describes connection properties for 802.11 Wi-Fi networks |

## Functions

NMSetting * | nm_setting_wireless_new ()
GBytes * | nm_setting_wireless_get_ssid ()
const char * | nm_setting_wireless_get_mode ()
const char * | nm_setting_wireless_get_band ()
guint32 | nm_setting_wireless_get_channel ()
const char * | nm_setting_wireless_get_bssid ()
guint32 | nm_setting_wireless_get_rate ()
guint32 | nm_setting_wireless_get_tx_power ()
const char * | nm_setting_wireless_get_mac_address ()
const char * | nm_setting_wireless_get_cloned_mac_address ()
const char * | nm_setting_wireless_get_generate_mac_address_mask ()
const char *const * | nm_setting_wireless_get_mac_address_blacklist ()
guint32 | nm_setting_wireless_get_num_mac_blacklist_items ()
const char * | nm_setting_wireless_get_mac_blacklist_item ()
gboolean | nm_setting_wireless_add_mac_blacklist_item ()
void | nm_setting_wireless_remove_mac_blacklist_item ()
gboolean | nm_setting_wireless_remove_mac_blacklist_item_by_value ()
void | nm_setting_wireless_clear_mac_blacklist_items ()
guint32 | nm_setting_wireless_get_mtu ()
gboolean | nm_setting_wireless_get_hidden ()
guint32 | nm_setting_wireless_get_powersave ()
NMSettingMacRandomization | nm_setting_wireless_get_mac_address_randomization ()
gboolean | nm_setting_wireless_add_seen_bssid ()
guint32 | nm_setting_wireless_get_num_seen_bssids ()
const char * | nm_setting_wireless_get_seen_bssid ()
gboolean | nm_setting_wireless_ap_security_compatible ()
NMSettingWirelessWakeOnWLan | nm_setting_wireless_get_wake_on_wlan ()
NMTernary | nm_setting_wireless_get_ap_isolation ()

## Properties

NMTernary | ap-isolation | Read / Write
char * | band | Read / Write
char * | bssid | Read / Write
guint | channel | Read / Write
char * | cloned-mac-address | Read / Write
char * | generate-mac-address-mask | Read / Write
gboolean | hidden | Read / Write
char * | mac-address | Read / Write
GStrv | mac-address-blacklist | Read / Write
guint | mac-address-randomization | Read / Write
char * | mode | Read / Write
guint | mtu | Read / Write
guint | powersave | Read / Write
guint | rate | Read / Write
GStrv | seen-bssids | Read / Write
GBytes * | ssid | Read / Write
guint | tx-power | Read / Write
guint | wake-on-wlan | Read / Write

## Types and Values

#define | NM_SETTING_WIRELESS_SETTING_NAME
enum | NMSettingWirelessWakeOnWLan
#define | NM_SETTING_WIRELESS_SSID
#define | NM_SETTING_WIRELESS_MODE
#define | NM_SETTING_WIRELESS_BAND
#define | NM_SETTING_WIRELESS_CHANNEL
#define | NM_SETTING_WIRELESS_BSSID
#define | NM_SETTING_WIRELESS_RATE
#define | NM_SETTING_WIRELESS_TX_POWER
#define | NM_SETTING_WIRELESS_MAC_ADDRESS
#define | NM_SETTING_WIRELESS_CLONED_MAC_ADDRESS
#define | NM_SETTING_WIRELESS_GENERATE_MAC_ADDRESS_MASK
#define | NM_SETTING_WIRELESS_MAC_ADDRESS_BLACKLIST
#define | NM_SETTING_WIRELESS_MTU
#define | NM_SETTING_WIRELESS_SEEN_BSSIDS
#define | NM_SETTING_WIRELESS_HIDDEN
#define | NM_SETTING_WIRELESS_POWERSAVE
#define | NM_SETTING_WIRELESS_MAC_ADDRESS_RANDOMIZATION
#define | NM_SETTING_WIRELESS_WAKE_ON_WLAN
#define | NM_SETTING_WIRELESS_AP_ISOLATION
#define | NM_SETTING_WIRELESS_MODE_ADHOC
#define | NM_SETTING_WIRELESS_MODE_AP
#define | NM_SETTING_WIRELESS_MODE_INFRA
#define | NM_SETTING_WIRELESS_MODE_MESH
enum | NMSettingWirelessPowersave
| NMSettingWireless

## Object Hierarchy

        GEnum
        ╰── NMSettingWirelessPowersave
        GFlags
        ╰── NMSettingWirelessWakeOnWLan
        GObject
        ╰── NMSetting
            ╰── NMSettingWireless

## Description

The NMSettingWireless object is a NMSetting subclass that describes properties necessary for connection to 802.11 Wi-Fi networks.

## Functions

### nm_setting_wireless_new ()

    NMSetting *
    nm_setting_wireless_new (void);

Creates a new NMSettingWireless object with default values.

#### Returns

the new empty NMSettingWireless object.

[transfer full]

### nm_setting_wireless_get_ssid ()

    GBytes *
    nm_setting_wireless_get_ssid (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “ssid” property of the setting.

[transfer none]

### nm_setting_wireless_get_mode ()

    const char *
    nm_setting_wireless_get_mode (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “mode” property of the setting

### nm_setting_wireless_get_band ()

    const char *
    nm_setting_wireless_get_band (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “band” property of the setting

### nm_setting_wireless_get_channel ()

    guint32
    nm_setting_wireless_get_channel (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “channel” property of the setting

### nm_setting_wireless_get_bssid ()

    const char *
    nm_setting_wireless_get_bssid (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “bssid” property of the setting

### nm_setting_wireless_get_rate ()

    guint32
    nm_setting_wireless_get_rate (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “rate” property of the setting

### nm_setting_wireless_get_tx_power ()

    guint32
    nm_setting_wireless_get_tx_power (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “tx-power” property of the setting

### nm_setting_wireless_get_mac_address ()

    const char *
    nm_setting_wireless_get_mac_address (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “mac-address” property of the setting

### nm_setting_wireless_get_cloned_mac_address ()

    const char *
    nm_setting_wireless_get_cloned_mac_address
                                   (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “cloned-mac-address” property of the setting

### nm_setting_wireless_get_generate_mac_address_mask ()

    const char *
    nm_setting_wireless_get_generate_mac_address_mask
                                   (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “generate-mac-address-mask” property of the setting

Since: 1.4

### nm_setting_wireless_get_mac_address_blacklist ()

    const char *const *
    nm_setting_wireless_get_mac_address_blacklist
                                   (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “mac-address-blacklist” property of the setting

### nm_setting_wireless_get_num_mac_blacklist_items ()

    guint32
    nm_setting_wireless_get_num_mac_blacklist_items
                                   (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the number of blacklisted MAC addresses

### nm_setting_wireless_get_mac_blacklist_item ()

    const char *
    nm_setting_wireless_get_mac_blacklist_item
                                   (NMSettingWireless *setting,
                                    guint32 idx);

#### Parameters

setting | the NMSettingWireless |
idx | the zero-based index of the MAC address entry |

#### Returns

the blacklisted MAC address string (hex-digits-and-colons notation) at index `idx`

### nm_setting_wireless_add_mac_blacklist_item ()

    gboolean
    nm_setting_wireless_add_mac_blacklist_item
                                   (NMSettingWireless *setting,
                                    const char *mac);

Adds a new MAC address to the “mac-address-blacklist” property.

#### Parameters

setting | the NMSettingWireless |
mac | the MAC address string (hex-digits-and-colons notation) to blacklist |

#### Returns

`TRUE` if the MAC address was added; `FALSE` if the MAC address is invalid or was already present

### nm_setting_wireless_remove_mac_blacklist_item ()

    void
    nm_setting_wireless_remove_mac_blacklist_item
                                   (NMSettingWireless *setting,
                                    guint32 idx);

Removes the MAC address at index `idx` from the blacklist.

#### Parameters

setting | the NMSettingWireless |
idx | index number of the MAC address |

### nm_setting_wireless_remove_mac_blacklist_item_by_value ()

    gboolean
    nm_setting_wireless_remove_mac_blacklist_item_by_value
                                   (NMSettingWireless *setting,
                                    const char *mac);

Removes the MAC address `mac` from the blacklist.

#### Parameters

setting | the NMSettingWireless |
mac | the MAC address string (hex-digits-and-colons notation) to remove from the blacklist |

#### Returns

`TRUE` if the MAC address was found and removed; `FALSE` if it was not.

### nm_setting_wireless_clear_mac_blacklist_items ()

    void
    nm_setting_wireless_clear_mac_blacklist_items
                                   (NMSettingWireless *setting);

Removes all blacklisted MAC addresses.

#### Parameters

setting | the NMSettingWireless |

### nm_setting_wireless_get_mtu ()

    guint32
    nm_setting_wireless_get_mtu (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “mtu” property of the setting

### nm_setting_wireless_get_hidden ()

    gboolean
    nm_setting_wireless_get_hidden (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “hidden” property of the setting

### nm_setting_wireless_get_powersave ()

    guint32
    nm_setting_wireless_get_powersave (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “powersave” property of the setting

Since: 1.2

### nm_setting_wireless_get_mac_address_randomization ()

    NMSettingMacRandomization
    nm_setting_wireless_get_mac_address_randomization
                                   (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “mac-address-randomization” property of the setting

Since: 1.2

### nm_setting_wireless_add_seen_bssid ()

    gboolean
    nm_setting_wireless_add_seen_bssid (NMSettingWireless *setting,
                                        const char *bssid);

Adds a new Wi-Fi AP's BSSID to the previously seen BSSID list of the setting. NetworkManager now tracks previously seen BSSIDs internally so this function no longer has much use. Actually, changes you make using this function will not be preserved.

#### Parameters

setting | the NMSettingWireless |
bssid | the new BSSID to add to the list |

#### Returns

`TRUE` if `bssid` was already known, `FALSE` if not

### nm_setting_wireless_get_num_seen_bssids ()

    guint32
    nm_setting_wireless_get_num_seen_bssids
                                   (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the number of BSSIDs in the previously seen BSSID list

### nm_setting_wireless_get_seen_bssid ()

    const char *
    nm_setting_wireless_get_seen_bssid (NMSettingWireless *setting,
                                        guint32 i);

#### Parameters

setting | the NMSettingWireless |
i | index of a BSSID in the previously seen BSSID list |

#### Returns

the BSSID at index `i`

### nm_setting_wireless_ap_security_compatible ()

    gboolean
    nm_setting_wireless_ap_security_compatible
                                   (NMSettingWireless *s_wireless,
                                    NMSettingWirelessSecurity *s_wireless_sec,
                                    NM80211ApFlags ap_flags,
                                    NM80211ApSecurityFlags ap_wpa,
                                    NM80211ApSecurityFlags ap_rsn,
                                    NM80211Mode ap_mode);

Given a NMSettingWireless and an optional NMSettingWirelessSecurity, determine if the configuration given by the settings is compatible with the security of an access point using that access point's capability flags and mode. Useful for clients that wish to filter a set of connections against a set of access points and determine which connections are compatible with which access points.

#### Parameters

s_wireless | a NMSettingWireless |
s_wireless_sec | a NMSettingWirelessSecurity or `NULL` |
ap_flags | the `NM80211ApFlags` of the given access point |
ap_wpa | the `NM80211ApSecurityFlags` of the given access point's WPA capabilities |
ap_rsn | the `NM80211ApSecurityFlags` of the given access point's WPA2/RSN capabilities |
ap_mode | the 802.11 mode of the AP, either Ad-Hoc or Infrastructure |

#### Returns

`TRUE` if the given settings are compatible with the access point's security flags and mode, `FALSE` if they are not.

### nm_setting_wireless_get_wake_on_wlan ()

    NMSettingWirelessWakeOnWLan
    nm_setting_wireless_get_wake_on_wlan (NMSettingWireless *setting);

Returns the Wake-on-WLAN options enabled for the connection

#### Parameters

setting | the NMSettingWireless |

#### Returns

the Wake-on-WLAN options

Since: 1.12

### nm_setting_wireless_get_ap_isolation ()

    NMTernary
    nm_setting_wireless_get_ap_isolation (NMSettingWireless *setting);

#### Parameters

setting | the NMSettingWireless |

#### Returns

the “ap-isolation” property of the setting

Since: 1.28

## Types and Values

### NM_SETTING_WIRELESS_SETTING_NAME

    #define NM_SETTING_WIRELESS_SETTING_NAME "802-11-wireless"

### enum NMSettingWirelessWakeOnWLan

Options for “wake-on-wlan”. Note that not all options are supported by all devices.

#### Members

NM_SETTING_WIRELESS_WAKE_ON_WLAN_NONE | Wake-on-WLAN disabled |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_ANY | Wake on any activity |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_DISCONNECT | Wake on disconnect |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_MAGIC | Wake on magic packet |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_GTK_REKEY_FAILURE | Wake on GTK rekey failure |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_EAP_IDENTITY_REQUEST | Wake on EAP identity request |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_4WAY_HANDSHAKE | Wake on 4way handshake |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_RFKILL_RELEASE | Wake on rfkill release |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_TCP |  |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_ALL | Wake on all events. This does not include the exclusive flags `NM_SETTING_WIRELESS_WAKE_ON_WLAN_DEFAULT` or `NM_SETTING_WIRELESS_WAKE_ON_WLAN_IGNORE` . |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_DEFAULT | Use the default value |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_IGNORE | Don't change configured settings |
NM_SETTING_WIRELESS_WAKE_ON_WLAN_EXCLUSIVE_FLAGS | Mask of flags that are incompatible with other flags |

Since: 1.12

### NM_SETTING_WIRELESS_SSID

    #define NM_SETTING_WIRELESS_SSID                      "ssid"

### NM_SETTING_WIRELESS_MODE

    #define NM_SETTING_WIRELESS_MODE                      "mode"

### NM_SETTING_WIRELESS_BAND

    #define NM_SETTING_WIRELESS_BAND                      "band"

### NM_SETTING_WIRELESS_CHANNEL

    #define NM_SETTING_WIRELESS_CHANNEL                   "channel"

### NM_SETTING_WIRELESS_BSSID

    #define NM_SETTING_WIRELESS_BSSID                     "bssid"

### NM_SETTING_WIRELESS_RATE

    #define NM_SETTING_WIRELESS_RATE                      "rate"

### NM_SETTING_WIRELESS_TX_POWER

    #define NM_SETTING_WIRELESS_TX_POWER                  "tx-power"

### NM_SETTING_WIRELESS_MAC_ADDRESS

    #define NM_SETTING_WIRELESS_MAC_ADDRESS               "mac-address"

### NM_SETTING_WIRELESS_CLONED_MAC_ADDRESS

    #define NM_SETTING_WIRELESS_CLONED_MAC_ADDRESS        "cloned-mac-address"

### NM_SETTING_WIRELESS_GENERATE_MAC_ADDRESS_MASK

    #define NM_SETTING_WIRELESS_GENERATE_MAC_ADDRESS_MASK "generate-mac-address-mask"

### NM_SETTING_WIRELESS_MAC_ADDRESS_BLACKLIST

    #define NM_SETTING_WIRELESS_MAC_ADDRESS_BLACKLIST     "mac-address-blacklist"

### NM_SETTING_WIRELESS_MTU

    #define NM_SETTING_WIRELESS_MTU                       "mtu"

### NM_SETTING_WIRELESS_SEEN_BSSIDS

    #define NM_SETTING_WIRELESS_SEEN_BSSIDS               "seen-bssids"

### NM_SETTING_WIRELESS_HIDDEN

    #define NM_SETTING_WIRELESS_HIDDEN                    "hidden"

### NM_SETTING_WIRELESS_POWERSAVE

    #define NM_SETTING_WIRELESS_POWERSAVE                 "powersave"

### NM_SETTING_WIRELESS_MAC_ADDRESS_RANDOMIZATION

    #define NM_SETTING_WIRELESS_MAC_ADDRESS_RANDOMIZATION "mac-address-randomization"

### NM_SETTING_WIRELESS_WAKE_ON_WLAN

    #define NM_SETTING_WIRELESS_WAKE_ON_WLAN              "wake-on-wlan"

### NM_SETTING_WIRELESS_AP_ISOLATION

    #define NM_SETTING_WIRELESS_AP_ISOLATION              "ap-isolation"

### NM_SETTING_WIRELESS_MODE_ADHOC

    #define NM_SETTING_WIRELESS_MODE_ADHOC "adhoc"

Indicates Ad-Hoc mode where no access point is expected to be present.

### NM_SETTING_WIRELESS_MODE_AP

    #define NM_SETTING_WIRELESS_MODE_AP "ap"

Indicates AP/master mode where the wireless device is started as an access point/hotspot.

### NM_SETTING_WIRELESS_MODE_INFRA

    #define NM_SETTING_WIRELESS_MODE_INFRA "infrastructure"

Indicates infrastructure mode where an access point is expected to be present for this connection.

### NM_SETTING_WIRELESS_MODE_MESH

    #define NM_SETTING_WIRELESS_MODE_MESH "mesh"

Indicates that the connection should create a mesh point.

Since: 1.20

### enum NMSettingWirelessPowersave

These flags indicate whether wireless powersave must be enabled.

#### Members

NM_SETTING_WIRELESS_POWERSAVE_DEFAULT | use the default value |
NM_SETTING_WIRELESS_POWERSAVE_IGNORE | don't touch existing setting |
NM_SETTING_WIRELESS_POWERSAVE_DISABLE | disable powersave |
NM_SETTING_WIRELESS_POWERSAVE_ENABLE | enable powersave |
_NM_SETTING_WIRELESS_POWERSAVE_NUM |  |
NM_SETTING_WIRELESS_POWERSAVE_LAST |  |

### NMSettingWireless

    typedef struct _NMSettingWireless NMSettingWireless;

Wi-Fi Settings

## Property Details

### The `“ap-isolation”` property

      “ap-isolation”             NMTernary

Configures AP isolation, which prevents communication between wireless devices connected to this AP. This property can be set to a value different from `NM_TERNARY_DEFAULT` only when the interface is configured in AP mode.

If set to `NM_TERNARY_TRUE`, devices are not able to communicate with each other. This increases security because it protects devices against attacks from other clients in the network. At the same time, it prevents devices to access resources on the same wireless networks as file shares, printers, etc.

If set to `NM_TERNARY_FALSE`, devices can talk to each other.

When set to `NM_TERNARY_DEFAULT`, the global default is used; in case the global default is unspecified it is assumed to be `NM_TERNARY_FALSE`.

Owner: NMSettingWireless

Flags: Read / Write

Default value: NM_TERNARY_DEFAULT

Since: 1.28

### The `“band”` property

      “band”                     char *

802.11 frequency band of the network. One of "a" for 5GHz 802.11a or "bg" for 2.4GHz 802.11. This will lock associations to the Wi-Fi network to the specific band, i.e. if "a" is specified, the device will not associate with the same network in the 2.4GHz band even if the network's settings are compatible. This setting depends on specific driver capability and may not work with all drivers.

Owner: NMSettingWireless

Flags: Read / Write

Default value: NULL

### The `“bssid”` property

      “bssid”                    char *

If specified, directs the device to only associate with the given access point. This capability is highly driver dependent and not supported by all devices. Note: this property does not control the BSSID used when creating an Ad-Hoc network and is unlikely to in the future.

Owner: NMSettingWireless

Flags: Read / Write

Default value: NULL

### The `“channel”` property

      “channel”                  guint

Wireless channel to use for the Wi-Fi connection. The device will only join (or create for Ad-Hoc networks) a Wi-Fi network on the specified channel. Because channel numbers overlap between bands, this property also requires the "band" property to be set.

Owner: NMSettingWireless

Flags: Read / Write

Default value: 0

### The `“cloned-mac-address”` property

      “cloned-mac-address”       char *

If specified, request that the device use this MAC address instead. This is known as MAC cloning or spoofing.

Beside explicitly specifying a MAC address, the special values "preserve", "permanent", "random" and "stable" are supported. "preserve" means not to touch the MAC address on activation. "permanent" means to use the permanent hardware address of the device. "random" creates a random MAC address on each connect. "stable" creates a hashed MAC address based on connection.stable-id and a machine dependent key.

If unspecified, the value can be overwritten via global defaults, see manual of NetworkManager.conf. If still unspecified, it defaults to "preserve" (older versions of NetworkManager may use a different default value).

On D-Bus, this field is expressed as "assigned-mac-address" or the deprecated "cloned-mac-address".

Owner: NMSettingWireless

Flags: Read / Write

Default value: NULL

### The `“generate-mac-address-mask”` property

      “generate-mac-address-mask” char *

With “cloned-mac-address” setting "random" or "stable", by default all bits of the MAC address are scrambled and a locally-administered, unicast MAC address is created. This property allows to specify that certain bits are fixed. Note that the least significant bit of the first MAC address will always be unset to create a unicast MAC address.

If the property is `NULL`, it is eligible to be overwritten by a default connection setting. If the value is still `NULL` or an empty string, the default is to create a locally-administered, unicast MAC address.

If the value contains one MAC address, this address is used as mask. The set bits of the mask are to be filled with the current MAC address of the device, while the unset bits are subject to randomization. Setting "FE:FF:FF:00:00:00" means to preserve the OUI of the current MAC address and only randomize the lower 3 bytes using the "random" or "stable" algorithm.

If the value contains one additional MAC address after the mask, this address is used instead of the current MAC address to fill the bits that shall not be randomized. For example, a value of "FE:FF:FF:00:00:00 68:F7:28:00:00:00" will set the OUI of the MAC address to 68:F7:28, while the lower bits are randomized. A value of "02:00:00:00:00:00 00:00:00:00:00:00" will create a fully scrambled globally-administered, burned-in MAC address.

If the value contains more than one additional MAC addresses, one of them is chosen randomly. For example, "02:00:00:00:00:00 00:00:00:00:00:00 02:00:00:00:00:00" will create a fully scrambled MAC address, randomly locally or globally administered.

Owner: NMSettingWireless

Flags: Read / Write

Default value: NULL

### The `“hidden”` property

      “hidden”                   gboolean

If `TRUE`, indicates that the network is a non-broadcasting network that hides its SSID. This works both in infrastructure and AP mode.

In infrastructure mode, various workarounds are used for a more reliable discovery of hidden networks, such as probe-scanning the SSID. However, these workarounds expose inherent insecurities with hidden SSID networks, and thus hidden SSID networks should be used with caution.

In AP mode, the created network does not broadcast its SSID.

Note that marking the network as hidden may be a privacy issue for you (in infrastructure mode) or client stations (in AP mode), as the explicit probe-scans are distinctly recognizable on the air.

Owner: NMSettingWireless

Flags: Read / Write

Default value: FALSE

### The `“mac-address”` property

      “mac-address”              char *

If specified, this connection will only apply to the Wi-Fi device whose permanent MAC address matches. This property does not change the MAC address of the device (i.e. MAC spoofing).

Owner: NMSettingWireless

Flags: Read / Write

Default value: NULL

### The `“mac-address-blacklist”` property

      “mac-address-blacklist”    GStrv

A list of permanent MAC addresses of Wi-Fi devices to which this connection should never apply. Each MAC address should be given in the standard hex-digits-and-colons notation (eg "00:11:22:33:44:55").

Owner: NMSettingWireless

Flags: Read / Write

### The `“mac-address-randomization”` property

      “mac-address-randomization” guint

One of `NM_SETTING_MAC_RANDOMIZATION_DEFAULT` (never randomize unless the user has set a global default to randomize and the supplicant supports randomization), `NM_SETTING_MAC_RANDOMIZATION_NEVER` (never randomize the MAC address), or `NM_SETTING_MAC_RANDOMIZATION_ALWAYS` (always randomize the MAC address). This property is deprecated for 'cloned-mac-address'.

`NMSettingWireless:mac-address-randomization` has been deprecated since version 1.4 and should not be used in newly-written code.

Deprecated by NMSettingWireless:cloned-mac-address property.

Owner: NMSettingWireless

Flags: Read / Write

Default value: 0

Since: 1.2

### The `“mode”` property

      “mode”                     char *

Wi-Fi network mode; one of "infrastructure", "mesh", "adhoc" or "ap". If blank, infrastructure is assumed.

Owner: NMSettingWireless

Flags: Read / Write

Default value: NULL

### The `“mtu”` property

      “mtu”                      guint

If non-zero, only transmit packets of the specified size or smaller, breaking larger packets up into multiple Ethernet frames.

Owner: NMSettingWireless

Flags: Read / Write

Default value: 0

### The `“powersave”` property

      “powersave”                guint

One of `NM_SETTING_WIRELESS_POWERSAVE_DISABLE` (disable Wi-Fi power saving), `NM_SETTING_WIRELESS_POWERSAVE_ENABLE` (enable Wi-Fi power saving), `NM_SETTING_WIRELESS_POWERSAVE_IGNORE` (don't touch currently configure setting) or `NM_SETTING_WIRELESS_POWERSAVE_DEFAULT` (use the globally configured value). All other values are reserved.

Owner: NMSettingWireless

Flags: Read / Write

Default value: 0

Since: 1.2

### The `“rate”` property

      “rate”                     guint

If non-zero, directs the device to only use the specified bitrate for communication with the access point. Units are in Kb/s, ie 5500 = 5.5 Mbit/s. This property is highly driver dependent and not all devices support setting a static bitrate.

Owner: NMSettingWireless

Flags: Read / Write

Default value: 0

### The `“seen-bssids”` property

      “seen-bssids”              GStrv

A list of BSSIDs (each BSSID formatted as a MAC address like "00:11:22:33:44:55") that have been detected as part of the Wi-Fi network. NetworkManager internally tracks previously seen BSSIDs. The property is only meant for reading and reflects the BSSID list of NetworkManager. The changes you make to this property will not be preserved.

Owner: NMSettingWireless

Flags: Read / Write

### The `“ssid”` property

      “ssid”                     GBytes *

SSID of the Wi-Fi network. Must be specified.

Owner: NMSettingWireless

Flags: Read / Write

### The `“tx-power”` property

      “tx-power”                 guint

If non-zero, directs the device to use the specified transmit power. Units are dBm. This property is highly driver dependent and not all devices support setting a static transmit power.

Owner: NMSettingWireless

Flags: Read / Write

Default value: 0

### The `“wake-on-wlan”` property

      “wake-on-wlan”             guint

The NMSettingWirelessWakeOnWLan options to enable. Not all devices support all options. May be any combination of `NM_SETTING_WIRELESS_WAKE_ON_WLAN_ANY`, `NM_SETTING_WIRELESS_WAKE_ON_WLAN_DISCONNECT`, `NM_SETTING_WIRELESS_WAKE_ON_WLAN_MAGIC`, `NM_SETTING_WIRELESS_WAKE_ON_WLAN_GTK_REKEY_FAILURE`, `NM_SETTING_WIRELESS_WAKE_ON_WLAN_EAP_IDENTITY_REQUEST`, `NM_SETTING_WIRELESS_WAKE_ON_WLAN_4WAY_HANDSHAKE`, `NM_SETTING_WIRELESS_WAKE_ON_WLAN_RFKILL_RELEASE`, `NM_SETTING_WIRELESS_WAKE_ON_WLAN_TCP` or the special values `NM_SETTING_WIRELESS_WAKE_ON_WLAN_DEFAULT` (to use global settings) and `NM_SETTING_WIRELESS_WAKE_ON_WLAN_IGNORE` (to disable management of Wake-on-LAN in NetworkManager).

Owner: NMSettingWireless

Flags: Read / Write

Default value: 1

Since: 1.12